//importing functions from d3
import { select, json, geoPath, geoEquirectangular } from 'd3';
//importing methods from TopoJSON 
import { feature } from 'topojson';

const svg = select('svg');

//selecting 'geoEquirectangular()' function to view the world map 
const projection = geoEquirectangular();
const pathGenerator = geoPath().projection(projection);

//defining class as 'sphere'
svg.append('path')
    .attr('class', 'sphere')
    .attr('d', pathGenerator({type: 'Sphere'}));

//.json file that has data to visualize the map
json('https://cdn.jsdelivr.net/npm/world-atlas@2/countries-110m.json')
  .then(data => {
    const countries = feature(data, data.objects.countries);
//'selectAll()' function to select all the element that matches the specified selector string
    svg.selectAll('path').data(countries.features)
//enter() creates the initial join of data to elements
      .enter().append('path')
        .attr('class', 'country')
        .attr('d', pathGenerator);
  });